function WriteData(dataType,data,extender){

var downloadDirectory = 'E:/DownloadedShowsNew/YouTube/';
var fileName = downloadDirectory + extender + '-tempLog.txt';
var file = new java.io.File(fileName);
var writer = new java.io.BufferedWriter(new java.io.FileWriter(fileName));
writer.write(dataType);
writer.newLine();
writer.write(data);
writer.close();
}

function WatchNextShow(extender){
var downloadDirectory = 'E:/DownloadedShowsNew/YouTube/';
var fileName = downloadDirectory + extender + '-tempLog.txt';
var file = new java.io.File(fileName);
if (!file.exists()){
 var shows = new java.util.ArrayList();
 var show = java.util.HashMap();
 show.put('reply','No more shows');
 shows.add(show);
 return shows;

}
var reader = new java.io.BufferedReader(new java.io.FileReader(fileName));
var dataType = reader.readLine();
var data = reader.readLine();
reader.close();


if (data == null){
var shows = new java.util.ArrayList();
 var show = java.util.HashMap();
 show.put('reply','No more shows');
 shows.add(show);
 return shows;

}
var nextShowArray = data.toString().split(",");
var numberOfShows = nextShowArray.length;

var nextShow = '';
var newNextShowArray = [];
for(var i = 0; i < numberOfShows;i++){
if (i==0){
 nextShow = nextShowArray[i];

}else{
newNextShowArray.push(nextShowArray[i]);
}
}

if (nextShow==''){
 var shows = new java.util.ArrayList();
 var show = java.util.HashMap();
 show.put('reply','No more shows');
 shows.add(show);
 return shows;
}

WriteData(dataType,newNextShowArray.toString() ,extender);

if (dataType == 'SageTVShow')
return WatchAiringID(nextShow,extender);
else if (dataType == 'YouTubeShow')
return WatchYouTubeID(nextShow,extender);
 

}


function WatchYouTubeID(vidId,extender) {

Command('Stop',extender);
var shows = new java.util.ArrayList();
var show = java.util.HashMap();

var ytpi = Packages.tmiranda.youtube;

var downloadDirectory = 'E:/DownloadedShowsNew/YouTube/';

var videos = ytpi.Videos();
var vidList = videos.getVideoForId(vidId);

var vidTitle = videos.getTitle(vidList.get(0));
var fixedTitle = vidTitle.replaceAll('[\\~#%&*{}/:<>?|\"]','_');

var fileName = downloadDirectory + fixedTitle + '.mp4';
var file = new java.io.File(fileName);

if (!file.exists()){


var urlGetter = ytpi.GetUrl(vidId);
urlGetter.run();
var url = urlGetter.getDownloadUrl();

var nullName = null;

Global.StartFileDownload(url,nullName,file);

while (Global.GetBackgroundFileDownloadStreamTime(file) < 5000)
 continue;

var tempMediaFile= MediaFileAPI.CreateTempMediaFile(file);

MediaFileAPI.SetMediaFileMetadata(tempMediaFile,
                                 'Title',
                                 'YouTube');

MediaFileAPI.SetMediaFileMetadata(tempMediaFile,
                                 'EpisodeName',
                                 vidTitle);
}
var UIContext =  Packages.sagex.UIContext;

if (extender == 0){
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(names[0]),file );
Global.SageCommand(new UIContext(names[0]),'TV');
}else{
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(extender),file );
Global.SageCommand(new UIContext(extender),'TV');
}

show.put('reply','Playing ' + fixedTitle );
shows.add(show);
return shows;


}


function WatchYouTube(name,extender) {
Command('Stop',extender);
var newSearchTerm = name.replace(/-/g, ' ');

var shows = new java.util.ArrayList();
var show = java.util.HashMap();

var ytpi = Packages.tmiranda.youtube;

var downloadDirectory = 'E:/DownloadedShowsNew/YouTube/';

var searchResults = ytpi.Search('viewCount');
var newResults = searchResults.searchAllByKeyword(newSearchTerm,5) ;

if (newResults == null || newResults.size() == 0){
show.put('reply','Nothing found');
shows.add(show);
return shows;

}

//var videoList = ytpi.Videos.searchListToVideoList(newResults);
var vidId = searchResults.getVideoId(newResults.get(0));
var vidTitle = searchResults.getTitle(newResults.get(0));

var fixedTitle = vidTitle.replaceAll('[\\~#%&*{}/:<>?|\"]','_');

var fileName = downloadDirectory + fixedTitle + '.mp4';

var file = new java.io.File(fileName);
if (!file.exists()){

var urlGetter = ytpi.GetUrl(vidId);
urlGetter.run();
var url = urlGetter.getDownloadUrl();

var nullName = null;

Global.StartFileDownload(url,nullName,file);

while (Global.GetBackgroundFileDownloadStreamTime(file) < 5000)
 continue;

var tempMediaFile= MediaFileAPI.CreateTempMediaFile(file);

MediaFileAPI.SetMediaFileMetadata(tempMediaFile,
                                 'Title',
                                 'YouTube');

MediaFileAPI.SetMediaFileMetadata(tempMediaFile,
                                 'EpisodeName',
                                 vidTitle);
}
var UIContext =  Packages.sagex.UIContext;

if (extender == 0){
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(names[0]),file );
Global.SageCommand(new UIContext(names[0]),'TV');
}else{
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(extender),file );
Global.SageCommand(new UIContext(extender),'TV');
}

show.put('reply','Playing ' + fixedTitle );
shows.add(show);

for(var i = 1 ; i < newResults.size() ; i++){
if(i == 1)
 nextShows = searchResults.getVideoId(newResults.get(i));
else
nextShows = nextShows + ',' + searchResults.getVideoId(newResults.get(i));

}

WriteData('YouTubeShow',nextShows ,extender);
return shows;


}

function getAllMethods(object) {
    return Object.getOwnPropertyNames(object).filter(function(property) {
        return typeof object[property] == 'function';
    });
}

function Command(cmd,extender) {
var UIContext =  Packages.sagex.UIContext;
if (extender == 0){
var names = Global.GetConnectedClients();
Global.SageCommand(new UIContext(names[0]),cmd);
}else
Global.SageCommand(new UIContext(extender),cmd);

}

function PlayPause() {
var UIContext =  Packages.sagex.UIContext;
var names = Global.GetConnectedClients();
MediaPlayerAPI.PlayPause(new UIContext(names[0]));

}


function WatchAiringID(airingID,extender) {
Command('Stop',extender);

var shows = new java.util.ArrayList();
var show = java.util.HashMap();

mf = AiringAPI.GetMediaFileForAiring(AiringAPI.GetAiringForID(airingID));

var showTitle = ShowAPI.GetShowTitle(mf);
var episodeTitle = ShowAPI.GetShowEpisode(mf);

if (showTitle == episodeTitle)
	show.put('reply','Playing ' + showTitle);
else
	show.put('reply','Playing ' + showTitle + ', ' + episodeTitle); 

shows.add(show);

   
var UIContext =  Packages.sagex.UIContext;

if (extender == 0){
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(names[0]),mf);
Global.SageCommand(new UIContext(names[0]),'TV');
}else{
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(extender),mf);
Global.SageCommand(new UIContext(extender),'TV');
}


   return shows;

}


function Watch(searchterm,extender) {
Command('Stop',extender);
var newSearchTerm = searchterm.replace(/-/g, ' ');

 var shows = new java.util.ArrayList();
   var searchresults = Database.FilterByMethod(Database.SearchSelectedFields(newSearchTerm,false,true,true,false,false,false,false,false,false,false), "GetMediaFileForAiring", null, false);
   
var s = searchresults.size();

if (s == 0){
var show = java.util.HashMap();
show.put('reply','I could not find ' + newSearchTerm);
shows.add(show);
return shows;

}

   if (s > 1){
	s = 6;
}

   var nextShows = '';
   for (var i=0;i<s;i++) {
      var airing = searchresults.get(i);
      
      var airingID = AiringAPI.GetAiringID(airing);
      if (airingID != 0){
          mf = AiringAPI.GetMediaFileForAiring(AiringAPI.GetAiringForID(airingID));

var showTitle = ShowAPI.GetShowTitle(mf);
var episodeTitle = ShowAPI.GetShowEpisode(mf);


if (i==0){
var show = java.util.HashMap();
if (showTitle == episodeTitle)
	show.put('reply','Playing ' + showTitle);
else
	show.put('reply','Playing ' + showTitle + ', ' + episodeTitle); 

shows.add(show);

var UIContext =  Packages.sagex.UIContext;

if (extender == 0){
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(names[0]),mf);
Global.SageCommand(new UIContext(names[0]),'TV');
}else{
var names = Global.GetConnectedClients();
MediaPlayerAPI.Watch(new UIContext(extender),mf);
Global.SageCommand(new UIContext(extender),'TV');
}

}else{
	if (i == 2)
nextShows = airingID.toString();
else
nextShows = nextShows + ',' + airingID.toString();

}
      }
   }

WriteData('SageTVShow',nextShows ,extender);
   return shows;
}

function GetNextRecordings() {
   var shows = new java.util.ArrayList();

   var airings = Global.GetScheduledRecordings();  
   var s = airings.length;
   var reply = '';

	if (s == 0)
return;

   if (s > 5){
	s = 5;
}
   
	for (var i=0;i<s;i++) {
      var airing = airings[i];
      reply += AiringAPI.GetAiringTitle(airing) + ', ';
	 
 }
var show = java.util.HashMap();
show.put('reply',reply);  
shows.add(show);
   return shows;

}

function GetNewShows() {
   var shows = new java.util.ArrayList();
   var files =  MediaFileAPI.GetMediaFiles("T");
   files = Database.Sort(files,true,"GetAiringStartTime");
   var s = files.length;
   if (s > 5)
	s = 5;

   var reply = '';   
for (var i=0;i<s;i++) {
      var mf = files[i];
      var show = java.util.HashMap();
	reply += MediaFileAPI.GetMediaTitle(mf) + ', ';      
   }
   show.put('reply', reply);
shows.add(show);
return shows;
}


                              